﻿package 
{
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;

	//import nl.interactionfigure.DrawAndMove;

	public class WebcamColourTracking extends Sprite
	{
		private const WIDTH:Number = 600;
		private const HEIGHT:Number = 450;

		private var cam:Camera;
		private var vid:Video;
		private var clearVid:Video;
		private var bmd:BitmapData;
		private var cbRect:Sprite;
		private var colour:Number = 0xFFFFFF;
		private var aRed:Array;
		private var aGreen:Array;
		private var aBlue:Array;


		public function WebcamColourTracking()
		{
			this.stage.align = StageAlign.TOP_LEFT;
			this.stage.scaleMode = StageScaleMode.NO_SCALE;
			this.stage.addEventListener(MouseEvent.MOUSE_UP, startMe);
		}
		private function startMe(e:MouseEvent):void
		{
			this.stage.removeEventListener(MouseEvent.MOUSE_UP, startMe);

			cam = Camera.getCamera();
			cam.setMode(WIDTH,HEIGHT,15);
			vid = new Video(WIDTH,HEIGHT);
			vid.attachCamera(cam);
			vid.filters = [new BlurFilter(10,10,1)];

			bmd = new BitmapData(WIDTH,HEIGHT,false);
			
			clearVid = new Video(WIDTH,HEIGHT);
			clearVid.attachCamera(cam);
			clearVid.x = WIDTH;
			clearVid.scaleX = -1;
			this.addChild(clearVid);

			cbRect = new Sprite();
			this.addChild(cbRect);

			makePaletteArrays();

			this.addEventListener(Event.ENTER_FRAME, updateStage);
			this.stage.addEventListener(MouseEvent.MOUSE_UP, stageClicked);
		}
		private function makePaletteArrays():void
		{
			aRed = [];
			aGreen = [];
			aBlue = [];
			var levels:Number = 8;
			var div:Number = 256 / levels;
			for (var i:Number=0; i<256; i++)
			{
				var value:Number = Math.floor(i / div) * div;
				aRed[i] = value << 16;
				aGreen[i] = value << 8;
				aBlue[i] = value;
			}
		}
		private function stageClicked(e:MouseEvent):void
		{
			colour = bmd.getPixel(this.mouseX,this.mouseY);
			clearVid.alpha = 0;
			instructions.visible = false;
		}
		
		private function updateStage(e:Event):void
		{
			
			bmd.draw(vid, new Matrix(-1,0,0,1,bmd.width,0));
			bmd.paletteMap(bmd, bmd.rect, new Point(), aRed, aGreen, aBlue);
			var rect:Rectangle = bmd.getColorBoundsRect(0xffffff,colour,true);
			cbRect.graphics.clear();
			cbRect.graphics.lineStyle(0, 0x00ff00,0 );
			cbRect.graphics.beginFill(0xff0000, 1);
			cbRect.graphics.drawRect(rect.x, rect.y, rect.width, rect.height);

		}
		//////////////
		public function get camWidth():Number
		{
			return WIDTH;
		}
		public function get camHeight():Number
		{
			return HEIGHT;
		}
		public function get pickedColour():Number
		{
			return colour;
		}
	}
}